package io.dekorate.halkyon.config;

import io.dekorate.project.Project;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.Configuration;
import io.dekorate.halkyon.model.DeploymentMode;
import java.lang.Object;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@io.sundr.builder.annotations.Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class ComponentConfig extends Configuration{

    private String name = "";
    private DeploymentMode deploymentMode = io.dekorate.halkyon.model.DeploymentMode.dev;
    private boolean exposeService = false;
    private io.dekorate.kubernetes.config.Env[] envs = new io.dekorate.kubernetes.config.Env[0];
    private String buildType = "s2i";
    private String remote = "origin";

    public ComponentConfig(){
    }
    public ComponentConfig(Project project,Map<ConfigKey,Object> attributes,String name,DeploymentMode deploymentMode,boolean exposeService,io.dekorate.kubernetes.config.Env[] envs,String buildType,String remote){
            super(project, attributes);
            this.name = name != null ? name : "";
            this.deploymentMode = deploymentMode != null ? deploymentMode : io.dekorate.halkyon.model.DeploymentMode.dev;
            this.exposeService = exposeService;
            this.envs = envs != null ? envs : new io.dekorate.kubernetes.config.Env[0];
            this.buildType = buildType != null ? buildType : "s2i";
            this.remote = remote != null ? remote : "origin";
    }

    public String getName(){
            return this.name;
    }

    public DeploymentMode getDeploymentMode(){
            return this.deploymentMode;
    }

    public boolean isExposeService(){
            return this.exposeService;
    }

    public io.dekorate.kubernetes.config.Env[] getEnvs(){
            return this.envs;
    }

    public String getBuildType(){
            return this.buildType;
    }

    public String getRemote(){
            return this.remote;
    }

    public static ComponentConfigBuilder newComponentConfigBuilder(){
            return new io.dekorate.halkyon.config.ComponentConfigBuilder();
    }




}
