package io.dekorate.halkyon.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.kubernetes.config.ConfigKey;
import java.lang.StringBuilder;
import io.dekorate.kubernetes.config.EnvFluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.dekorate.kubernetes.config.ConfigurationFluent;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.project.Project;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.config.EnvBuilder;
import java.lang.Deprecated;
import java.util.Iterator;
import io.dekorate.halkyon.model.DeploymentMode;
import java.util.Collection;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;

public interface ComponentConfigFluent<A extends ComponentConfigFluent<A>> extends ConfigurationFluent<A>{


    public String getName();
    public A withName(String name);
    public Boolean hasName();
    public A withNewName(String arg1);
    public A withNewName(StringBuilder arg1);
    public A withNewName(StringBuffer arg1);
    public DeploymentMode getDeploymentMode();
    public A withDeploymentMode(DeploymentMode deploymentMode);
    public Boolean hasDeploymentMode();
    public boolean isExposeService();
    public A withExposeService(boolean exposeService);
    public Boolean hasExposeService();
    public A withEnvs(io.dekorate.kubernetes.config.Env... envs);
    
/**
 * This method has been deprecated, please use method buildEnvs instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Env[] getEnvs();
    public io.dekorate.kubernetes.config.Env[] buildEnvs();
    public io.dekorate.kubernetes.config.Env buildEnv(int index);
    public io.dekorate.kubernetes.config.Env buildFirstEnv();
    public io.dekorate.kubernetes.config.Env buildLastEnv();
    public io.dekorate.kubernetes.config.Env buildMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public Boolean hasMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public A addToEnvs(int index,io.dekorate.kubernetes.config.Env item);
    public A setToEnvs(int index,io.dekorate.kubernetes.config.Env item);
    public A addToEnvs(io.dekorate.kubernetes.config.Env... items);
    public A addAllToConfigEnvs(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeFromEnvs(io.dekorate.kubernetes.config.Env... items);
    public A removeAllFromConfigEnvs(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeMatchingFromConfigEnvs(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public Boolean hasEnvs();
    public A addNewConfigEnv(String name,String value,String secret,String configmap,String field);
    public ComponentConfigFluent.ConfigEnvsNested<A> addNewConfigEnv();
    public ComponentConfigFluent.ConfigEnvsNested<A> addNewEnvLike(io.dekorate.kubernetes.config.Env item);
    public ComponentConfigFluent.ConfigEnvsNested<A> setNewEnvLike(int index,io.dekorate.kubernetes.config.Env item);
    public ComponentConfigFluent.ConfigEnvsNested<A> editEnv(int index);
    public ComponentConfigFluent.ConfigEnvsNested<A> editFirstEnv();
    public ComponentConfigFluent.ConfigEnvsNested<A> editLastEnv();
    public ComponentConfigFluent.ConfigEnvsNested<A> editMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public String getBuildType();
    public A withBuildType(String buildType);
    public Boolean hasBuildType();
    public A withNewBuildType(String arg1);
    public A withNewBuildType(StringBuilder arg1);
    public A withNewBuildType(StringBuffer arg1);
    public String getRemote();
    public A withRemote(String remote);
    public Boolean hasRemote();
    public A withNewRemote(String arg1);
    public A withNewRemote(StringBuilder arg1);
    public A withNewRemote(StringBuffer arg1);

    public interface ConfigEnvsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,io.dekorate.kubernetes.config.EnvFluent<ComponentConfigFluent.ConfigEnvsNested<N>>{

        
    public N and();    public N endConfigEnv();
}


}
