package io.dekorate.halkyon.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.kubernetes.config.ConfigurationFluentImpl;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.config.EnvBuilder;
import io.dekorate.kubernetes.config.EnvFluentImpl;
import java.lang.Deprecated;
import java.util.Iterator;
import io.dekorate.halkyon.model.DeploymentMode;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

public class ComponentConfigFluentImpl<A extends ComponentConfigFluent<A>> extends ConfigurationFluentImpl<A> implements ComponentConfigFluent<A>{

    private String name = "";
    private DeploymentMode deploymentMode = io.dekorate.halkyon.model.DeploymentMode.dev;
    private boolean exposeService = false;
    private List<io.dekorate.kubernetes.config.EnvBuilder> envs =  new ArrayList<io.dekorate.kubernetes.config.EnvBuilder>();
    private String buildType = "s2i";
    private String remote = "origin";

    public ComponentConfigFluentImpl(){
    }
    public ComponentConfigFluentImpl(ComponentConfig instance){
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
            this.withName(instance.getName()); 
            this.withDeploymentMode(instance.getDeploymentMode()); 
            this.withExposeService(instance.isExposeService()); 
            this.withEnvs(instance.getEnvs()); 
            this.withBuildType(instance.getBuildType()); 
            this.withRemote(instance.getRemote()); 
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public Boolean hasName(){
            return this.name != null;
    }

    public A withNewName(String arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1){
            return (A)withName(new String(arg1));
    }

    public DeploymentMode getDeploymentMode(){
            return this.deploymentMode;
    }

    public A withDeploymentMode(DeploymentMode deploymentMode){
            this.deploymentMode=deploymentMode; return (A) this;
    }

    public Boolean hasDeploymentMode(){
            return this.deploymentMode != null;
    }

    public boolean isExposeService(){
            return this.exposeService;
    }

    public A withExposeService(boolean exposeService){
            this.exposeService=exposeService; return (A) this;
    }

    public Boolean hasExposeService(){
            return true;
    }

    public A withEnvs(io.dekorate.kubernetes.config.Env... envs){
            if (this.envs != null) {this.envs.clear();}
            if (envs != null) {for (io.dekorate.kubernetes.config.Env item :envs){ this.addToEnvs(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildEnvs instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Env[] getEnvs(){
            int size = envs != null ? envs.size() : 0;
io.dekorate.kubernetes.config.Env[] result = new io.dekorate.kubernetes.config.Env[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Env,?> builder : envs) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Env[] buildEnvs(){
            int size = envs != null ? envs.size() : 0;
io.dekorate.kubernetes.config.Env[] result = new io.dekorate.kubernetes.config.Env[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Env,?> builder : envs) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Env buildEnv(int index){
            return this.envs.get(index).build();
    }

    public io.dekorate.kubernetes.config.Env buildFirstEnv(){
            return this.envs.get(0).build();
    }

    public io.dekorate.kubernetes.config.Env buildLastEnv(){
            return this.envs.get(envs.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.Env buildMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate){
            for (io.dekorate.kubernetes.config.EnvBuilder item: envs) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate){
            for (io.dekorate.kubernetes.config.EnvBuilder item: envs) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToEnvs(int index,io.dekorate.kubernetes.config.Env item){
            if (this.envs == null) {this.envs = new ArrayList<io.dekorate.kubernetes.config.EnvBuilder>();}
            io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envs").add(index >= 0 ? index : _visitables.get("envs").size(), builder);this.envs.add(index >= 0 ? index : envs.size(), builder); return (A)this;
    }

    public A setToEnvs(int index,io.dekorate.kubernetes.config.Env item){
            if (this.envs == null) {this.envs = new ArrayList<io.dekorate.kubernetes.config.EnvBuilder>();}
            io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);
            if (index < 0 || index >= _visitables.get("envs").size()) { _visitables.get("envs").add(builder); } else { _visitables.get("envs").set(index, builder);}
            if (index < 0 || index >= envs.size()) { envs.add(builder); } else { envs.set(index, builder);}
             return (A)this;
    }

    public A addToEnvs(io.dekorate.kubernetes.config.Env... items){
            if (this.envs == null) {this.envs = new ArrayList<io.dekorate.kubernetes.config.EnvBuilder>();}
            for (io.dekorate.kubernetes.config.Env item : items) {io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envs").add(builder);this.envs.add(builder);} return (A)this;
    }

    public A addAllToConfigEnvs(Collection<io.dekorate.kubernetes.config.Env> items){
            if (this.envs == null) {this.envs = new ArrayList<io.dekorate.kubernetes.config.EnvBuilder>();}
            for (io.dekorate.kubernetes.config.Env item : items) {io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envs").add(builder);this.envs.add(builder);} return (A)this;
    }

    public A removeFromEnvs(io.dekorate.kubernetes.config.Env... items){
            for (io.dekorate.kubernetes.config.Env item : items) {io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envs").remove(builder);if (this.envs != null) {this.envs.remove(builder);}} return (A)this;
    }

    public A removeAllFromConfigEnvs(Collection<io.dekorate.kubernetes.config.Env> items){
            for (io.dekorate.kubernetes.config.Env item : items) {io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envs").remove(builder);if (this.envs != null) {this.envs.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromConfigEnvs(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate){
            if (envs == null) return (A) this;
            final Iterator<io.dekorate.kubernetes.config.EnvBuilder> each = envs.iterator();
            final List visitables = _visitables.get("envs");
            while (each.hasNext()) {
              io.dekorate.kubernetes.config.EnvBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasEnvs(){
            return envs != null && !envs.isEmpty();
    }

    public A addNewConfigEnv(String name,String value,String secret,String configmap,String field){
            return (A)addToEnvs(new Env(name, value, secret, configmap, field));
    }

    public ComponentConfigFluent.ConfigEnvsNested<A> addNewConfigEnv(){
            return new ConfigEnvsNestedImpl();
    }

    public ComponentConfigFluent.ConfigEnvsNested<A> addNewEnvLike(io.dekorate.kubernetes.config.Env item){
            return new ConfigEnvsNestedImpl(-1, item);
    }

    public ComponentConfigFluent.ConfigEnvsNested<A> setNewEnvLike(int index,io.dekorate.kubernetes.config.Env item){
            return new ConfigEnvsNestedImpl(index, item);
    }

    public ComponentConfigFluent.ConfigEnvsNested<A> editEnv(int index){
            if (envs.size() <= index) throw new RuntimeException("Can't edit envs. Index exceeds size.");
            return setNewEnvLike(index, buildEnv(index));
    }

    public ComponentConfigFluent.ConfigEnvsNested<A> editFirstEnv(){
            if (envs.size() == 0) throw new RuntimeException("Can't edit first envs. The list is empty.");
            return setNewEnvLike(0, buildEnv(0));
    }

    public ComponentConfigFluent.ConfigEnvsNested<A> editLastEnv(){
            int index = envs.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last envs. The list is empty.");
            return setNewEnvLike(index, buildEnv(index));
    }

    public ComponentConfigFluent.ConfigEnvsNested<A> editMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate){
            int index = -1;
            for (int i=0;i<envs.size();i++) { 
            if (predicate.apply(envs.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching envs. No match found.");
            return setNewEnvLike(index, buildEnv(index));
    }

    public String getBuildType(){
            return this.buildType;
    }

    public A withBuildType(String buildType){
            this.buildType=buildType; return (A) this;
    }

    public Boolean hasBuildType(){
            return this.buildType != null;
    }

    public A withNewBuildType(String arg1){
            return (A)withBuildType(new String(arg1));
    }

    public A withNewBuildType(StringBuilder arg1){
            return (A)withBuildType(new String(arg1));
    }

    public A withNewBuildType(StringBuffer arg1){
            return (A)withBuildType(new String(arg1));
    }

    public String getRemote(){
            return this.remote;
    }

    public A withRemote(String remote){
            this.remote=remote; return (A) this;
    }

    public Boolean hasRemote(){
            return this.remote != null;
    }

    public A withNewRemote(String arg1){
            return (A)withRemote(new String(arg1));
    }

    public A withNewRemote(StringBuilder arg1){
            return (A)withRemote(new String(arg1));
    }

    public A withNewRemote(StringBuffer arg1){
            return (A)withRemote(new String(arg1));
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ComponentConfigFluentImpl that = (ComponentConfigFluentImpl) o;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            if (deploymentMode != null ? !deploymentMode.equals(that.deploymentMode) :that.deploymentMode != null) return false;
            if (exposeService != that.exposeService) return false;
            if (envs != null ? !envs.equals(that.envs) :that.envs != null) return false;
            if (buildType != null ? !buildType.equals(that.buildType) :that.buildType != null) return false;
            if (remote != null ? !remote.equals(that.remote) :that.remote != null) return false;
            return true;
    }


    public class ConfigEnvsNestedImpl<N> extends io.dekorate.kubernetes.config.EnvFluentImpl<ComponentConfigFluent.ConfigEnvsNested<N>> implements ComponentConfigFluent.ConfigEnvsNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final io.dekorate.kubernetes.config.EnvBuilder builder;
        private final int index;
    
            ConfigEnvsNestedImpl(int index,io.dekorate.kubernetes.config.Env item){
                    this.index = index;
                    this.builder = new io.dekorate.kubernetes.config.EnvBuilder(this, item);
            }
            ConfigEnvsNestedImpl(){
                    this.index = -1;
                    this.builder = new io.dekorate.kubernetes.config.EnvBuilder(this);
            }
    
    public N and(){
            return (N) ComponentConfigFluentImpl.this.setToEnvs(index, builder.build());
    }
    public N endConfigEnv(){
            return and();
    }

}


}
