package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Boolean;

public interface LinkSpecFluent<A extends LinkSpecFluent<A>> extends Fluent<A>{


    public String getComponentName();
    public A withComponentName(String componentName);
    public Boolean hasComponentName();
    public A withNewComponentName(String arg1);
    public A withNewComponentName(StringBuilder arg1);
    public A withNewComponentName(StringBuffer arg1);
    public Type getType();
    public A withType(Type type);
    public Boolean hasType();
    public String getRef();
    public A withRef(String ref);
    public Boolean hasRef();
    public A withNewRef(String arg1);
    public A withNewRef(StringBuilder arg1);
    public A withNewRef(StringBuffer arg1);
    public A withEnvs(Env... envs);
    
/**
 * This method has been deprecated, please use method buildEnvs instead.
 */
@Deprecated public Env[] getEnvs();
    public Env[] buildEnvs();
    public Env buildEnv(int index);
    public Env buildFirstEnv();
    public Env buildLastEnv();
    public Env buildMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public Boolean hasMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public A addToEnvs(int index,Env item);
    public A setToEnvs(int index,Env item);
    public A addToEnvs(Env... items);
    public A addAllToEnvs(Collection<Env> items);
    public A removeFromEnvs(Env... items);
    public A removeAllFromEnvs(Collection<Env> items);
    public A removeMatchingFromEnvs(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public Boolean hasEnvs();
    public A addNewEnv(String name,String value);
    public LinkSpecFluent.EnvsNested<A> addNewEnv();
    public LinkSpecFluent.EnvsNested<A> addNewEnvLike(Env item);
    public LinkSpecFluent.EnvsNested<A> setNewEnvLike(int index,Env item);
    public LinkSpecFluent.EnvsNested<A> editEnv(int index);
    public LinkSpecFluent.EnvsNested<A> editFirstEnv();
    public LinkSpecFluent.EnvsNested<A> editLastEnv();
    public LinkSpecFluent.EnvsNested<A> editMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);

    public interface EnvsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,EnvFluent<LinkSpecFluent.EnvsNested<N>>{

        
    public N and();    public N endEnv();
}


}
