package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

public class LinkSpecFluentImpl<A extends LinkSpecFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements LinkSpecFluent<A>{

    private String componentName;
    private Type type;
    private String ref;
    private List<EnvBuilder> envs;

    public LinkSpecFluentImpl(){
    }
    public LinkSpecFluentImpl(LinkSpec instance){
            this.withComponentName(instance.getComponentName()); 
            this.withType(instance.getType()); 
            this.withRef(instance.getRef()); 
            this.withEnvs(instance.getEnvs()); 
    }

    public String getComponentName(){
            return this.componentName;
    }

    public A withComponentName(String componentName){
            this.componentName=componentName; return (A) this;
    }

    public Boolean hasComponentName(){
            return this.componentName != null;
    }

    public A withNewComponentName(String arg1){
            return (A)withComponentName(new String(arg1));
    }

    public A withNewComponentName(StringBuilder arg1){
            return (A)withComponentName(new String(arg1));
    }

    public A withNewComponentName(StringBuffer arg1){
            return (A)withComponentName(new String(arg1));
    }

    public Type getType(){
            return this.type;
    }

    public A withType(Type type){
            this.type=type; return (A) this;
    }

    public Boolean hasType(){
            return this.type != null;
    }

    public String getRef(){
            return this.ref;
    }

    public A withRef(String ref){
            this.ref=ref; return (A) this;
    }

    public Boolean hasRef(){
            return this.ref != null;
    }

    public A withNewRef(String arg1){
            return (A)withRef(new String(arg1));
    }

    public A withNewRef(StringBuilder arg1){
            return (A)withRef(new String(arg1));
    }

    public A withNewRef(StringBuffer arg1){
            return (A)withRef(new String(arg1));
    }

    public A withEnvs(Env... envs){
            if (this.envs != null) {this.envs.clear();}
            if (envs != null) {for (Env item :envs){ this.addToEnvs(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildEnvs instead.
 */
@Deprecated public Env[] getEnvs(){
            int size = envs != null ? envs.size() : 0;
Env[] result = new Env[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends Env,?> builder : envs) {
    result[index++]=builder.build();
}
return result;

    }

    public Env[] buildEnvs(){
            int size = envs != null ? envs.size() : 0;
Env[] result = new Env[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends Env,?> builder : envs) {
    result[index++]=builder.build();
}
return result;

    }

    public Env buildEnv(int index){
            return this.envs.get(index).build();
    }

    public Env buildFirstEnv(){
            return this.envs.get(0).build();
    }

    public Env buildLastEnv(){
            return this.envs.get(envs.size() - 1).build();
    }

    public Env buildMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate){
            for (EnvBuilder item: envs) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate){
            for (EnvBuilder item: envs) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToEnvs(int index,Env item){
            if (this.envs == null) {this.envs = new ArrayList<EnvBuilder>();}
            EnvBuilder builder = new EnvBuilder(item);_visitables.get("envs").add(index >= 0 ? index : _visitables.get("envs").size(), builder);this.envs.add(index >= 0 ? index : envs.size(), builder); return (A)this;
    }

    public A setToEnvs(int index,Env item){
            if (this.envs == null) {this.envs = new ArrayList<EnvBuilder>();}
            EnvBuilder builder = new EnvBuilder(item);
            if (index < 0 || index >= _visitables.get("envs").size()) { _visitables.get("envs").add(builder); } else { _visitables.get("envs").set(index, builder);}
            if (index < 0 || index >= envs.size()) { envs.add(builder); } else { envs.set(index, builder);}
             return (A)this;
    }

    public A addToEnvs(Env... items){
            if (this.envs == null) {this.envs = new ArrayList<EnvBuilder>();}
            for (Env item : items) {EnvBuilder builder = new EnvBuilder(item);_visitables.get("envs").add(builder);this.envs.add(builder);} return (A)this;
    }

    public A addAllToEnvs(Collection<Env> items){
            if (this.envs == null) {this.envs = new ArrayList<EnvBuilder>();}
            for (Env item : items) {EnvBuilder builder = new EnvBuilder(item);_visitables.get("envs").add(builder);this.envs.add(builder);} return (A)this;
    }

    public A removeFromEnvs(Env... items){
            for (Env item : items) {EnvBuilder builder = new EnvBuilder(item);_visitables.get("envs").remove(builder);if (this.envs != null) {this.envs.remove(builder);}} return (A)this;
    }

    public A removeAllFromEnvs(Collection<Env> items){
            for (Env item : items) {EnvBuilder builder = new EnvBuilder(item);_visitables.get("envs").remove(builder);if (this.envs != null) {this.envs.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromEnvs(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate){
            if (envs == null) return (A) this;
            final Iterator<EnvBuilder> each = envs.iterator();
            final List visitables = _visitables.get("envs");
            while (each.hasNext()) {
              EnvBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasEnvs(){
            return envs != null && !envs.isEmpty();
    }

    public A addNewEnv(String name,String value){
            return (A)addToEnvs(new Env(name, value));
    }

    public LinkSpecFluent.EnvsNested<A> addNewEnv(){
            return new EnvsNestedImpl();
    }

    public LinkSpecFluent.EnvsNested<A> addNewEnvLike(Env item){
            return new EnvsNestedImpl(-1, item);
    }

    public LinkSpecFluent.EnvsNested<A> setNewEnvLike(int index,Env item){
            return new EnvsNestedImpl(index, item);
    }

    public LinkSpecFluent.EnvsNested<A> editEnv(int index){
            if (envs.size() <= index) throw new RuntimeException("Can't edit envs. Index exceeds size.");
            return setNewEnvLike(index, buildEnv(index));
    }

    public LinkSpecFluent.EnvsNested<A> editFirstEnv(){
            if (envs.size() == 0) throw new RuntimeException("Can't edit first envs. The list is empty.");
            return setNewEnvLike(0, buildEnv(0));
    }

    public LinkSpecFluent.EnvsNested<A> editLastEnv(){
            int index = envs.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last envs. The list is empty.");
            return setNewEnvLike(index, buildEnv(index));
    }

    public LinkSpecFluent.EnvsNested<A> editMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate){
            int index = -1;
            for (int i=0;i<envs.size();i++) { 
            if (predicate.apply(envs.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching envs. No match found.");
            return setNewEnvLike(index, buildEnv(index));
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            LinkSpecFluentImpl that = (LinkSpecFluentImpl) o;
            if (componentName != null ? !componentName.equals(that.componentName) :that.componentName != null) return false;
            if (type != null ? !type.equals(that.type) :that.type != null) return false;
            if (ref != null ? !ref.equals(that.ref) :that.ref != null) return false;
            if (envs != null ? !envs.equals(that.envs) :that.envs != null) return false;
            return true;
    }


    public class EnvsNestedImpl<N> extends EnvFluentImpl<LinkSpecFluent.EnvsNested<N>> implements LinkSpecFluent.EnvsNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final EnvBuilder builder;
        private final int index;
    
            EnvsNestedImpl(int index,Env item){
                    this.index = index;
                    this.builder = new EnvBuilder(this, item);
            }
            EnvsNestedImpl(){
                    this.index = -1;
                    this.builder = new EnvBuilder(this);
            }
    
    public N and(){
            return (N) LinkSpecFluentImpl.this.setToEnvs(index, builder.build());
    }
    public N endEnv(){
            return and();
    }

}


}
